%define systemdsystemunitdir %(pkg-config systemd --variable=systemdsystemunitdir)

Name:           bootchart 
Version:        0.14.0
Release:        1.3.git20110630%{?dist}
Summary:        Boot Process Performance Visualization
License:        GPLv2+ and GPLv3+
URL:            https://github.com/mmeeks/bootchart
Source0:        https://github.com/downloads/mmeeks/bootchart/bootchart2-%{version}.tar.bz2
Patch1: 0001-bootchartd-Expect-dmesg-log-only-if-bootchartd-run-a.patch
Patch2: 0002-Update-NEWS.patch
Patch3: 0003-Fix-tests-import-path-so-we-can-call-them-from-sourc.patch
Patch4: 0004-tests-update-parsing-tests-for-ParserState-Trace-cha.patch
Patch5: 0005-tests-Fix-errors-and-failures-of-testParseProcPsLog.patch
Patch6: 0006-tests-remove-unuseful-testParseLogDir.patch
Patch7: 0007-tests-update-for-Trace-and-ProcessTree-api-changes.patch
Patch8: 0008-Add-Makefile-target-for-executing-pybootchartgui-tes.patch
Patch9: 0009-Fix-self-reference-in-bootchartd-SEE-ALSO-section-ma.patch
Patch10: 0010-pybootchartgui-support-hp-smart-arrays-block-device.patch
Patch11: 0011-pybootchartgui-fix-hp-smart-array-regexp.patch
Patch12: 0012-bootchartd-Look-for-bootchart_init-in-the-environmen.patch
Patch13: 0013-pybootchartgui-main.py-fix-output-filename.patch
Patch14: 0014-pybootchartgui-main.py.in-set-default-format-to-png.patch
Patch15: 0015-parsing.py-_parse_proc_stat_log-skip-empty-lines.patch
Patch16: 0016-collector-move-to-run-bootchart-instead-of-dev-.boot.patch

Group:          Applications/System
BuildRequires:	python
BuildRequires:	systemd-units
Requires:	bootchart-daemon
Requires:	pygtk2

%description
A tool for performance analysis and visualization of the GNU/Linux boot
process. Resource utilization and process information are collected during
the boot process and are later rendered in a PNG, SVG or EPS encoded chart.

%package daemon
Summary:    Bootchart logger script
Group:		Applications/System
Requires(post):   systemd-units
Requires(preun):  systemd-units
Requires(postun): systemd-units

%description daemon
A tool for performance analysis and visualization of the GNU/Linux boot
process. This package includes the standalone logger daemon and configuration
file.

%prep
%setup -q -n bootchart2-%{version}
%patch1 -p1 -b .git1
%patch2 -p1 -b .git2
%patch3 -p1 -b .git3
%patch4 -p1 -b .git4
%patch5 -p1 -b .git5
%patch6 -p1 -b .git6
%patch7 -p1 -b .git7
%patch8 -p1 -b .git8
%patch9 -p1 -b .git9
%patch10 -p1 -b .git10
%patch11 -p1 -b .git11
%patch12 -p1 -b .git12
%patch13 -p1 -b .git13
%patch14 -p1 -b .git14
%patch15 -p1 -b .git15
%patch16 -p1 -b .git16

%build
make CFLAGS="$RPM_OPT_FLAGS" 

# bootchart adds 'site-packages' itself, so we just want eg /usr/lib/python2.7 here
%define python_libdir `echo "%{python_sitelib}" | sed 's/\\/site-packages//'`

%install
make install \
	DESTDIR=$RPM_BUILD_ROOT \
	PY_LIBDIR=%{python_libdir}\
	NO_PYTHON_COMPILE=1 \
	SYSTEMD_UNIT_DIR=%{systemdsystemunitdir}

ln -s pybootchartgui $RPM_BUILD_ROOT%{_bindir}/bootchart

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/dracut.conf.d
echo 'add_dracutmodules+=" bootchart "' > $RPM_BUILD_ROOT%{_sysconfdir}/dracut.conf.d/bootchartd.conf

rm -f  $RPM_BUILD_ROOT/usr/share/docs/bootchart/README $RPM_BUILD_ROOT/usr/share/docs/bootchart/README.pybootchart


%clean
rm -rf $RPM_BUILD_ROOT

%post daemon
# Add a new grub/lilo entry
if [ -x /sbin/grubby ] && [ -e /boot/grub/grub.conf ]; then
    eval $( /sbin/grubby --info /boot/vmlinuz-$(uname -r) ) >& /dev/null
    if [ "x$kernel" != "x" ]; then
	/sbin/grubby --update-kernel=/boot"$kernel" --args="init=/sbin/bootchartd"
    fi
fi
if [ $1 -eq 1 ]; then
        # Package install, not upgrade
	/bin/systemctl enable bootchart.service >/dev/null 2>&1 || :
fi

%preun daemon
# Remove the grub/lilo entry, but only on uninstall, not on upgrade
if [ $1 -eq 0 ] && [ -x /sbin/grubby ] && [ -e /boot/grub/grub.conf ]; then
    grubby --update-kernel=ALL --remove-args="init=/sbin/bootchartd"
fi
if [ $1 -eq 0 ] ; then
    # Package removal, not upgrade
    /bin/systemctl disable bootchart.service >/dev/null 2>&1 || :
fi

%postun daemon
/bin/systemctl daemon-reload >/dev/null 2>&1 || :

%files
%defattr(-,root,root,-)
%doc AUTHORS COPYING NEWS README* TODO
%attr(0755,root,root) %{_bindir}/pybootchartgui
%{_bindir}/bootchart
%{python_sitelib}/*
%{_mandir}/man1/bootchart2.1*
%{_mandir}/man1/pybootchartgui.1*

%files daemon
%defattr(-,root,root,-)
%doc AUTHORS COPYING NEWS README* TODO
%attr(0755,root,root) /sbin/bootchartd
%dir %attr(0755,root,root) /lib/bootchart
/lib/bootchart/*
%{systemdsystemunitdir}/*
%config(noreplace) %{_sysconfdir}/bootchartd.conf
%config(noreplace) %{_sysconfdir}/dracut.conf.d/bootchartd.conf
%{_mandir}/man1/bootchartd.1*

%changelog
* Thu Jun 30 2011 Harald Hoyer <harald@redhat.com> 0.14.0-1.3.git20110630
- update to latest git
- fixed write bug 
Resolves: rhbz#699934

* Thu Apr 07 2011 Harald Hoyer <harald@redhat.com> 0.14.0-1.2.git20110331
- fixed output filename

* Thu Mar 31 2011 Harald Hoyer <harald@redhat.com> 0.14.0-1.1.git20110331
- version 0.14.0
- make use of /run

* Mon Feb 13 2011 Dan Williams <dcbw@redhat.com> 0.12.4-6.1.git20101122
- really fix python subdir

* Wed Feb 09 2011 Harald Hoyer <harald@redhat.com> 0.12.4-5.1.git20101122
- fixed python subdir

* Mon Feb 07 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.12.4-4.1.git20101122
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Mon Nov 22 2010 Harald Hoyer <harald@redhat.com> 0.12.4-3.1.git20101122
- fixed netlink interface for PROC_EVENT
- add dracut conf file, to add bootchart module
- updated rpm to latest git

* Fri Nov 19 2010 Harald Hoyer <harald@redhat.com> 0.12.4-2.1.git20101119
- merged our patches with upstream git
- added fixes to upstream git for initramfs rdinit=/sbin/bootchartd
- added systemd service files upstream
- updated rpm to latest git

* Wed Nov  3 2010 Bill Nottingham <notting@redhat.com - 0.12.4-1
- use new bootchart daemon & rendering code

* Wed Nov  3 2010 Marcela Mašláňová <mmaslano@redhat.com> - 0.9-12
- 475062 apply patch from Curtis Doty with few adjustment. daemon sub-package shouldn't
 install useless requirements on server.

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.9-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Mon Feb 23 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.9-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Wed Mar 19 2008 Warren Togami <wtogami@redhat.com> - 0.9-9
- Make bootchart work with readonly root
- Stop data collection when ldm process appears
- Make install/remove work in a chroot without grub.conf

* Mon Feb 18 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 0.9-8
- Autorebuild for GCC 4.3

* Tue Jan 22 2008 Adam Jackson <ajax@redhat.com> 0.9-7
- Only munge the grub config for the currently-running kernel; otherwise,
  if you dual-boot between multiple Linuxes, installing bootchart on one
  will break boot of the other.  Note that if you have multiple roots
  running the same kernel, this will still break.

* Mon Oct 29 2007 Adam Jackson <ajax@redhat.com> 0.9-6
- Don't remove bootchart from grub.conf on upgrade. (#349101)

* Mon Aug 27 2007 Adam Jackson <ajax@redhat.com> 0.9-5
- Additional minor spec cleanups from review bug (#219889)

* Fri Aug 24 2007 Adam Jackson <ajax@redhat.com> 0.9-4
- Fold the subpackages together, not really worth splitting.
- Add gcj pre-compilation.

* Thu Aug 16 2007 Adam Jackson <ajax@redhat.com> 0.9-3
- Fix license.
- Change logger group to System Environment/Base.
- install -p.
- Change buildroot to the new dogma.

* Wed Aug 15 2007 Adam Jackson <ajax@redhat.com> 0.9-2
- Update URL
- Change Group to Apps/System.
- Merge the base (renderer) and javadoc subpackages.
- Force use of bootchartd when it's installed, rather than only install
  it for the current kernel or mess with rpm triggers.

* Fri Dec 15 2006 John (J5) Palmieri <johnp@redhat.com> - 0.9-1
- Initial fedora package 
